<script setup>
import { ref } from "vue";
import TaskDialog from "src/components/TaskDialog.vue";
import TaskItem from "src/components/TaskItem.vue";
import { useTaskStore } from "src/stores/task";

const taskDialog = ref(false);
const selectedTask = ref(null);
const taskStore = useTaskStore();

const toggleTaskDialog = () => {
  taskDialog.value = !taskDialog.value;
};

const createTask = () => {
  (selectedTask.value = null), toggleTaskDialog();
};

const editTask = (task) => {
  selectedTask.value = task;
  toggleTaskDialog();
};
</script>

<template>
  <q-page>
    <TaskDialog
      v-if="taskDialog"
      v-model="taskDialog"
      :task="selectedTask"
      @close-dialog="taskDialog = false"
    ></TaskDialog>

    <TaskItem
      v-for="task in taskStore.taskList"
      :key="task.id"
      :task="task"
      @on-select-task="editTask($event)"
    ></TaskItem>

    <div v-if="taskStore.taskList.length < 1">
      <div class="flex flex-center column q-pa-lg">
        Nenhuma tarefa foi criada ainda.
        <q-btn @click="createTask" class="q-ma-sm" flat color="primary"
          >Criar agora</q-btn
        >
      </div>
    </div>
    <q-page-sticky position="bottom-right" :offset="[18, 18]">
      <q-btn @click="createTask" fab icon="add" color="primary" />
    </q-page-sticky>
  </q-page>
</template>
